﻿namespace UpdateBinding.ViewModel
{
  using System;
  using System.ComponentModel;
  using System.Linq.Expressions;
  using System.Windows.Input;

  using UpdateBinding.Model;

  public class UpdateBindingViewModel: INotifyPropertyChanged
  {
    private UpdateBindingModel _ubm;
    public event PropertyChangedEventHandler PropertyChanged;

    private ICommand _buttonClick;

    public UpdateBindingViewModel()
    {
      _ubm = new UpdateBindingModel();
      _ubm.Name = "Predefined value";
      _buttonClick = new RelayCommand(this.UpdateBinding);
    }

    public UpdateBindingModel Ubm 
    {
      get
      {
        return _ubm;
      }
      set
      {
        _ubm = value;
      }
    }

    public ICommand OnButtonClick
    {
      get
      {
        return _buttonClick;
      }
      set
      {
        _buttonClick = value;
      }
    }

    protected void OnPropertyChanged<T>(Expression<Func<T>> property)
    {
      if (this.PropertyChanged != null)
      {
        var mex = property.Body as MemberExpression;
        string name = mex.Member.Name;
        this.PropertyChanged(this, new PropertyChangedEventArgs(name));
      }
    }

    public void UpdateBinding(object obj)
    {
      Ubm.Name = "Updated value";
      OnPropertyChanged(() => this.Ubm);
    }

  }
}